unit EnabEdit;

{$mode objfpc}{$H+}

interface

uses
  Windows, Messages, Classes, SysUtils, LResources, Forms, Controls, Graphics,
  Dialogs, StdCtrls;

type
  TEnabEdit = class(TEdit)
  private
    FEnabChars: Set of Char;
    procedure SetEnabChars(Value:String);
    function GetEnabChars:String;
    { Private declarations }
  protected
    procedure KeyPress(var Key:Char);override;
    { Protected declarations }
  public
    constructor Create(AOwner:TComponent);override;
    { Public declarations }
  published
    property EnabledChars:String read GetEnabChars
                                 write SetEnabChars;
    { Published declarations }
  end;

procedure Register;

implementation

constructor TEnabEdit.Create(AOwner:TComponent);
begin
  Inherited Create(AOwner);
  FEnabChars:=[];
end;

procedure TEnabEdit.SetEnabChars(Value:String);
var i: Integer;
begin
  FEnabChars:=[];
  for i:=1 to length(value) Do FEnabChars:=FEnabChars+[Value[i]];
end;

function TEnabEdit.GetEnabChars:String;
var i: Integer;
begin
  Result:='';
  For i:=0 to 255 Do If Chr(i) In FEnabChars then Result:= Result+Chr(i);
end;

procedure TEnabEdit.KeyPress(var Key:Char);
begin
  if (Key in FEnabChars) or (Key=#8) then Inherited KeyPress(Key)
  else begin
        Key:=#0;
        Beep;
       end;
end;


procedure Register;
begin
  RegisterComponents('Standard',[TEnabEdit]);
end;

end.
